// Copyright (c) 1999, A.H. van den Boogaard

#ifndef DRAWSHAPE_H
#define DRAWSHAPE_H

#include <vector>

class DrawShape
{
   protected:
      DrawShape(){}

   public:
      virtual ~DrawShape(){}
      virtual void get_draw_points( std::vector<int>& /*points*/ ) const {};
};

class DrawTriangular:public DrawShape
{
   protected:
      DrawTriangular(){}

   public:
      ~DrawTriangular(){}
};

class DrawTri_lin:public DrawTriangular
{
   public:
      DrawTri_lin(){}
      ~DrawTri_lin(){}
      void get_draw_points( std::vector<int>& points ) const;
};

class DrawTri_quad:public DrawTriangular
{
   public:
      DrawTri_quad():DrawTriangular(){}
      ~DrawTri_quad(){}
      void get_draw_points( std::vector<int>& points ) const;
};

class DrawTri_quad_alt:public DrawTriangular
{
   public:
      DrawTri_quad_alt():DrawTriangular(){}
      ~DrawTri_quad_alt(){}
      void get_draw_points( std::vector<int>& points ) const;
};

class DrawQuadrilateral:public DrawShape
{
   protected:
      DrawQuadrilateral(){}

   public:
      ~DrawQuadrilateral(){}
};

class DrawQuad_lin:public DrawQuadrilateral
{
   public:
      DrawQuad_lin():DrawQuadrilateral(){}
      ~DrawQuad_lin(){}
      void get_draw_points( std::vector<int>& points ) const;
};

class DrawQuad_quad:public DrawQuadrilateral
{
   public:
      DrawQuad_quad():DrawQuadrilateral(){}
      ~DrawQuad_quad(){}
      void get_draw_points( std::vector<int>& points ) const;
};

class DrawQuad_quad_alt:public DrawQuadrilateral
{
   public:
      DrawQuad_quad_alt():DrawQuadrilateral(){}
      ~DrawQuad_quad_alt(){}
      void get_draw_points( std::vector<int>& points ) const;
};

class DrawHexagonal:public DrawShape
{
   protected:
      DrawHexagonal(){}

   public:
      ~DrawHexagonal(){}
};

class DrawHex_lin:public DrawHexagonal
{
   public:
      DrawHex_lin():DrawHexagonal(){}
      ~DrawHex_lin(){}
};

#endif // DRAWSHAPE_H
