// Copyright (c) 1999, A.H. van den Boogaard

#include "material.h"
#include "ftmatrix.h"
#include "tensor.h"

FeaTure::Vector Tensor2StrainVector( const Tensor2Sym &eps, bool expanded,
                                     FeaTure::StressType st );
FeaTure::Vector Tensor2StressVector( const Tensor2Sym &sig, bool expanded,
                                     FeaTure::StressType st );
Tensor2Sym StressVector2Tensor( const FeaTure::Vector &stress, bool expanded,
                                FeaTure::StressType st );
Tensor2Sym StrainVector2Tensor( const FeaTure::Vector &strain, bool expanded,
                                FeaTure::StressType st );

void Tensor2CollectArray( const Tensor2Gen& T, FeaTure::CollectArray *C );
void CollectArray2Tensor( const FeaTure::CollectArray &C, Tensor2Gen *T );
