// Copyright (c) 1999, A.H. van den Boogaard

// For compilers that support precompilation, includes "wx.h".
#include <wx/wxprec.h>
#ifdef __BORLANDC__
#pragma hdrstop
#endif
#ifndef WX_PRECOMP
#include <wx/wx.h>
#endif

#include "graphics.h"

DrawProperties::DrawProperties()
{
  init();
} 

void DrawProperties::init()
{
   elmnr = nodenr = displaced = false;
   undeformed = true;

   magnify  = 1.0;
   frequency = 1;
   slowdown  = 0.0;

   graphicsFont      = wxFont(11, wxROMAN, wxNORMAL, wxNORMAL);
   graphicsFontColor = wxColour( "BLACK" );
   elementFont       = wxFont(11, wxSWISS, wxNORMAL, wxBOLD);
   elementFontColor  = wxColour( "RED" );
   nodeFont          = wxFont(11, wxSWISS, wxNORMAL, wxNORMAL);
   nodeFontColor     = wxColour( "BLUE" );
}
